Color = Class.Create(Object, function(instance, red, green, blue)

--  Initialization
	instance._Red   = red   or 0
	instance._Green = green or 0
	instance._Blue  = blue  or 0

end)

function Color:Red()
	return self._Red
end

function Color:Green()
	return self._Green
end

function Color:Blue()
	return self._Blue
end

function Color:ToHexadecimal()

	local __Output = ""
	local __Rgb    = { self._Red, self._Green, self._Blue }
 
	for __Key, __Value in pairs(__Rgb) do
	
		local __Hexadecimal = ""
 
		while(__Value > 0) do
		
			local __Index = math.fmod(__Value, 16) + 1
			
			__Value = math.floor(__Value / 16)
			__Hexadecimal = string.sub("0123456789ABCDEF", __Index, __Index) .. __Hexadecimal		
				
		end
 
		if(string.len(__Hexadecimal) == 0) then
			__Hexadecimal = "00"
 
		elseif(string.len(__Hexadecimal) == 1) then
			__Hexadecimal = "0" .. __Hexadecimal
		end
 
		__Output = __Output .. __Hexadecimal
		
	end
 
	return __Output
end

function Color:ToString()
	return self:ToHexadecimal()
end
