Message = Class.Create(Object, function(instance, message, color)

--  Initialization
	instance._Buffer = ""
	instance._Color  = color or Colors.Default()

	if message ~= nil then
		if string.len(message) > 0 then
			instance:Append(message)
		end
	end

end)

function Message:Append(message, color)
	local __Color  = color or self._Color
	local __Buffer = string.format("|c%s%s", __Color:ToString(), message)
	
	self._Buffer = self._Buffer .. __Buffer
end

function Message:ToString()
	return self._Buffer
end
